# Copyright 2021-2023 H2020 TeraFlow (https://www.teraflow-h2020.eu/)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import logging
from typing import Dict
from sqlalchemy import Column, Float, String
from sqlalchemy.dialects.postgresql import UUID
from sqlalchemy.orm import relationship
from ._Base import _Base

LOGGER = logging.getLogger(__name__)

class ContextModel(_Base):
    __tablename__ = 'context'
    context_uuid = Column(UUID(as_uuid=False), primary_key=True)
    context_name = Column(String(), nullable=False)
    created_at   = Column(Float)

    topology = relationship('TopologyModel', back_populates='context')

    def dump_id(self) -> Dict:
        return {'context_uuid': {'uuid': self.context_uuid}}

    #@staticmethod
    #def main_pk_name():
    #    return 'context_uuid'

    """    
    def dump_service_ids(self) -> List[Dict]:
        from .ServiceModel import ServiceModel # pylint: disable=import-outside-toplevel
        db_service_pks = self.references(ServiceModel)
        return [ServiceModel(self.database, pk).dump_id() for pk,_ in db_service_pks]

    def dump_topology_ids(self) -> List[Dict]:
        from .TopologyModel import TopologyModel # pylint: disable=import-outside-toplevel
        db_topology_pks = self.references(TopologyModel)
        return [TopologyModel(self.database, pk).dump_id() for pk,_ in db_topology_pks]
    """

    def dump(self,
        include_services : bool = True,     # pylint: disable=arguments-differ
        include_slices : bool = True,       # pylint: disable=arguments-differ
        include_topologies : bool = True    # pylint: disable=arguments-differ
    ) -> Dict:
        result = {'context_id': self.dump_id(), 'name': self.context_name}
        # if include_services: result['service_ids'] = self.dump_service_ids()
        # if include_slices: result['slice_ids'] = self.dump_slice_ids()
        # if include_topologies: result['topology_ids'] = self.dump_topology_ids()
        return result
